//Born to kill

//#include <move.h>
//#include <ros.h>
//#include <std_msgs/Int16.h>
//#include <std_msgs/Byte.h>
#include  <DynamixelWorkbench.h>
#define DEVICE_NAME "3" 

#define BAUDRATE  1000000 //частота обращения к двигателям 
#define CAM_ID    51 //ID камеры робота

// Касательно гироскопа
//___________________
// Аналоговые выходы на openCM
const int analogInPinX = 0;
const int analogInPinY = 1; 
const int analogInPinZ = 2;

// Объявление переменных значнеия осей
int axisX = 0;
int axisY = 0;
int axisZ = 0;
//___________________


int32_t goal_position[20]; //массив позиций моторчиков (20 штук)
int32_t goal_velocity[20]; //массив скоростей моторчиков (20 штук)
uint16_t model_number;
uint8_t dxl_id[20]; //массив IDшников моторчиков (тоже 20)
const uint8_t handler_index = 0;
int prev_motion=0;
DynamixelWorkbench dxl_wb;
#define ROS_RATE 50000
//ros::NodeHandle_<ArduinoHardware, 3, 3, 150, 150> nh;
//ros::NodeHandle nh;
//размеры мяча новые и стары в x и y, так же координаты центра мяча новые и старые x_goal и y_goal 
int16_t y = 0;
int16_t y_old = 0;
int16_t x_old = 0;
int16_t x = 0;
int16_t y_goal = 0;
int16_t y_old_goal = 0;
int16_t x_old_goal = 0;
int16_t x_goal = 0;
//флаги на нахождение мача в зоне видимости
bool Ball_Detect = false;
bool Goal_Detect = false;
//HardwareTimer Timer(TIMER_CH4);


bool start_flag = true;

HardwareTimer Timer(TIMER_CH3);
void setup() 
{
  // Инициализация пинов (гиро)
  pinMode(analogInPinX, INPUT_ANALOG);
  pinMode(analogInPinY, INPUT_ANALOG);
  pinMode(analogInPinZ, INPUT_ANALOG);
  
  Serial.begin(57600);
  pinMode(13, INPUT);
  init_dxl();
  Timer.stop();
  Timer.setPeriod(100000);  //0.05Гц в микросекундах
  Timer.attachInterrupt(read_cam);
  Timer.start();
  
  
}

void loop() 
{ 
  if(digitalRead(13) == 0){
  int Motion_number = 0;
  Motion_number = make_decision();
  //switch всех возможных движений 
  switch (Motion_number){
  case 0:
    ready_for_walk(x,y);
    prev_motion = 0;
    break;
  case 1:
  if(prev_motion == 1)
    FFT_M(x,y);
  else
    FFT_F(x,y);
    prev_motion = 1;
    break;
  case 2:
    if(prev_motion == 2)
      TURN_L(x,y,false);
    else if(prev_motion == 1){
      set_leg();
      TURN_L(x,y,true);}
    else
      TURN_L(x,y,true);
      prev_motion = 2;
    break;
  case 3:
    if(prev_motion == 3)
      TURN_R(x,y,false);
    else if(prev_motion == 1){
      set_leg();
      TURN_R(x,y,true);}
    else
      TURN_R(x,y,true);
      prev_motion = 3;
    break;
  case 4:
    if(prev_motion == 1){
      set_leg();
      F_Shoot_L(x,y);}
    else
      F_Shoot_L(x,y);
    prev_motion = 4;
    wait(200);
    break;
  case 5:
    if(prev_motion == 1){
      set_leg();
      F_Shoot_R(x,y);}
    else
      F_Shoot_R(x,y);
    prev_motion = 5;
    wait(200);
    break;
  case 6:
    M_L(x,y);
    prev_motion = 6;
    break;
  case 7:
    M_R(x,y);
    prev_motion = 7;
    break;
  case 8:
    if(prev_motion == 1){
      set_leg();
      Search_Ball();}
    else
      Search_Ball();
    prev_motion = 8;
    break;
  case 9:
    GET_UP_BACK(x,y);
    prev_motion = 9;
    wait(200);
    break;
  case 10:
    GET_UP_FRONT(x,y);
    prev_motion = 10;
    wait(200);
    break;
  
  default:
    ready_for_walk(x,y);
    break;
  }
 }
 else{
  ready_for_walk(x,y);
 }  
}
//функция принятия решений
int make_decision(){
  axisX = analogRead(analogInPinX);
  axisY = analogRead(analogInPinY);
  axisZ = analogRead(analogInPinZ);
  Serial.print("X = " );
  Serial.print(axisX);
  Serial.print("\tY = " );
  Serial.print(axisY);
  Serial.print("\tZ = " );
  Serial.print(axisZ);
  Serial.print("\n");
  if((axisZ >= 560 ) && (axisZ <= 620)){//если стоит 
    if(Ball_Detect == true){
      if(abs(x)>=25){ //повернуться на мяч 
        return(turn_on_ball());
      }
      else
        if(y < 55){ //если мяч не у ног
         return(1); //пойти к мячу 
      }
      else{
        if (abs(x_old_goal) <= 25)
          return(hit_ball()); //ударить по мячу
        else
          if(x_old_goal>0){
            return(7);}//шаг вправо боком
          else{
            return(6);}//шаг влево боком
    }
   }
    else{ 
      return(8); //поиск мяча
    }
  }
   else 
  if((axisZ > 520) && (axisZ <= 560))//упал на спину
  {return(9);}//подняться со спины
  else
  if((axisZ >= 500) && (axisZ < 520))//упал на живот
    {return(10);}//встать с живота
}
int turn_on_ball(){
  if(x>0)
    return(2);//поворот на месте налево
  else
    return(3);//поворот на месте направо
}
int hit_ball(){
  if(x>0 & x < 135)
    return(4);//ударить левой ногой
  else
    return(5);//ударить правой ногой
}
void read_cam(void){
  int16_t cx = 0;
  int16_t cy = 0;
  int16_t cx_goal = 0;
  int16_t cy_goal = 0;
  int max_n = 1;
  for (int i = 0; i < max_n; i++)//цикл обнаружения
  {
    uint32_t resp[16];
    if (!dxl_wb.readRegister(CAM_ID, 16 + i * 16, 16, resp))
      break;
    int idx = 0;
    int8_t flag = resp[idx++];
    if (flag == 0xFF){
      break;}
    cx = resp[idx] + (resp[idx + 1] << 8);
    idx+=2;
    cy = resp[idx] + (resp[idx + 1] << 8);
    if((cx == -1) && (cy == -1))
      Ball_Detect = false;
    else{ //privodim v nuzhniy vid
      Ball_Detect = true;
      if(cx<0)
        cx = map(cx,0,-32768,-55,0);
      else
        cx = map(cx,32768,0,0,55);
      if(cy<0)
        cy = map(cy,0,-32768,-55,0);
      else
        cy = map(cy,32768,0,0,55);
    }
    //Serial.println("x  " + String(cx) + "y  " + String(cy)); //printing centre of ball
  }
    for (int i = 1; i < 2; i++)// cicle for detection
  {
    uint32_t resp[16];
    if (!dxl_wb.readRegister(CAM_ID, 16 + i * 16, 16, resp))
      break;
    int idx = 0;
    int8_t flag = resp[idx++];
    if (flag == 0xFF){
      break;}
    cx_goal = resp[idx] + (resp[idx + 1] << 8);
    idx+=2;
    cy_goal = resp[idx] + (resp[idx + 1] << 8);
    if((cx_goal == -1) && (cy_goal == -1))
      Goal_Detect = false;
    else{ //privodim v nuzhniy vid
      Goal_Detect = true;
      if(cx_goal<0)
        cx_goal = map(cx,0,-32768,-55,0);
      else
        cx_goal = map(cx,32768,0,0,55);
      if(cy_goal<0)
        cy_goal = map(cy,0,-32768,-55,0);
      else
        cy_goal = map(cy,32768,0,0,55);
    }
    //Serial.println("x  " + String(cx) + "y  " + String(cy)); //printing centre of ball
  }
  if(Goal_Detect == true){//change x and y for neck
      y_goal=y_goal-round(0.12*cy_goal);
      if(y_goal>60)
        y_goal = 60;
      if(y_goal<-15)
        y_goal = -15;
      x_goal=x_goal+round(0.2*cx_goal);
      if(x_goal>60)
        x_goal = 60;
      if(x_goal<-60)
        x_goal = -60;
        x_old_goal = x_goal;
     // Serial.println("x_goal  " + String(x_goal) + "y_goal  " + String(y_goal)); 
    }
  if(Ball_Detect == true){//change x and y for neck
      y=y-round(0.12*cy);
      if(y>60)
        y = 60;
      if(y<-15)
        y = -15;
      x=x+round(0.2*cx);
      if(x>60)
        x = 60;
      if(x<-60)
        x = -60;
     // Serial.println("x  " + String(x) + "y  " + String(y)); 
    }
}

void wait(int t)
{
  int t1 = 0;
  t1 = millis();
  while((millis()-t1)<=t){//nh.spinOnce();}
  }
  
}

//проверка моторчиков на местах
void init_dxl(){
  model_number = 0;
  dxl_wb.init(DEVICE_NAME, BAUDRATE);
  while(!dxl_wb.ping(CAM_ID)){}
  for (int i = 0;i<20; i++){
    dxl_id[i]=i+1;
  }
  for (int cnt = 0; cnt < 6; cnt++)
  {
    dxl_wb.ping(dxl_id[cnt], &model_number); //руки
    dxl_wb.jointMode(dxl_id[cnt], 250, 0); 
    goal_velocity[cnt] = 250;
  }
  for (int cnt = 6; cnt < 18; cnt++)
  {
    dxl_wb.ping(dxl_id[cnt], &model_number); //ноги
    dxl_wb.jointMode(dxl_id[cnt], 270, 0);
    goal_velocity[cnt] = 270; 
  }
  for (int cnt = 18; cnt < 20; cnt++)
  {
    dxl_wb.ping(dxl_id[cnt], &model_number); //шея
    dxl_wb.jointMode(cnt, 100, 0);
    goal_velocity[cnt] = 100; 
  }
  dxl_wb.addSyncWriteHandler(dxl_id[0], "Goal_Position"); //Simultaneous testing
  dxl_wb.addSyncWriteHandler(dxl_id[0], "Moving_Speed"); //Simultaneous testing
  dxl_wb.syncWrite(dxl_id[0], goal_velocity); //taking decision from 0 to 1023
 
}
void send_vel(int vel){
  
  for (int cnt = 6; cnt < 18; cnt++)
  {
    goal_velocity[cnt] = vel; 
  }
 
  dxl_wb.syncWrite(1, goal_velocity);
}

void setMotors(long m1,long m2,long m3,long m4,long m5,long m6,long m7,long m8,long m9,long m10,long m11,long m12,long m13,long m14,long m15,long m16,long m17,long m18,int m19,int m20,int delayy){
  bool result = false;                        //            __
  goal_position[0]=map(m1,-150,150,0,1023);   //           |18|
  goal_position[1]=map(m2,-150,150,0,1023);   //           |__|
  goal_position[2]=map(m3,-150,150,0,1023);   //   __ __   |19|  __ __
  goal_position[3]=map(m4,-150,150,0,1023);   //  | 2| 0|  |__| | 1| 3|
  goal_position[4]=map(m5,-150,150,0,1023);   //  |__|__|__   __|__|__|
  goal_position[5]=map(m6,-150,150,0,1023);   //  | 4|  | 6| | 7|  | 5|
  goal_position[6]=map(m7,-150,150,0,1023);   //  |__|  |__| |__|  |__|
  goal_position[7]=map(m8,-150,150,0,1023);   //         __   __
  goal_position[8]=map(m9,-150,150,0,1023);   //        | 8| | 9|
  goal_position[9]=map(m10,-150,150,0,1023);  //        |__| |__|
  goal_position[10]=map(m11,-150,150,0,1023); //        |10| |11|
  goal_position[11]=map(m12,-150,150,0,1023); //        |__| |__|
  goal_position[12]=map(m13,-150,150,0,1023); //         __   __
  goal_position[13]=map(m14,-150,150,0,1023); //        |12| |13|
  goal_position[14]=map(m15,-150,150,0,1023); //        |__| |__|
  goal_position[15]=map(m16,-150,150,0,1023); //         __   __
  goal_position[16]=map(m17,-150,150,0,1023); //        |16| |17|
  goal_position[17]=map(m18,-150,150,0,1023); //        |__| |__|
  goal_position[18]=map(y,-150,150,0,1023);   //        |14| |15|
  goal_position[19]=map(x,-150,150,0,1023);   //        |__| |__|
  result=dxl_wb.syncWrite(handler_index, &goal_position[0]);
  wait(delayy);
} 
void ready_for_walk(int w1, int w2){//приготовиться к ходьбе
  send_vel(50);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,50,-50,-1,1,y,x,50);
}
void set_leg(){
  send_vel(600);
  setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-67,53,-101,101, 49,-55,  4,10,y,x,80);
  setMotors(-80,100,-68,68,-14,14,-45,45,-9,12,-64,73,-101,115, 52,-64,  4,10,y,x,100);
  setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-67,67,-103,102, 50,-50, -5,5,y,x,100);
  
  send_vel(270);
}
void FFT_M(int w1, int w2){//шаг вперёд
  send_vel(400);
   setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-68,54,-102,102, 49,-55,  4,10,y,x,90);
  setMotors(-80,100,-68,68,-14,14,-45,45,-9,12,-65,74,-102,115, 52,-64,  4,10,y,x,100);
  setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-54,68,-102,102, 55,-49, -5,5,y,x,90);

  setMotors(-100,80,-68,68,-14,14,-45,45,-5,5,-54,68,-102,102, 55,-49, -10,-4,y,x,90);
  setMotors(-100,80,-68,68,-14,14,-45,45,-12,9,-74,65,-115,102, 64,-52, -10,-4,y,x,100);
  setMotors(-100,80,-68,68,-14,14,-45,45,-5,5,-68,54,-102,102, 49,-55,  -5,5,y,x,90);
  send_vel(270);
}
void FFT_F(int w1, int w2){
  send_vel(400);
   setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-68,54,-102,102, 49,-55,  4,10,y,x,90);
  setMotors(-80,100,-68,68,-14,14,-45,45,-9,12,-65,74,-102,115, 52,-64,  4,10,y,x,100);
  setMotors(-80,100,-68,68,-14,14,-45,45,-5,5,-54,68,-102,102, 55,-49, -5,5,y,x,90);

  setMotors(-100,80,-68,68,-14,14,-45,45,-5,5,-54,68,-102,102, 55,-49, -10,-4,y,x,90);
  setMotors(-100,80,-68,68,-14,14,-45,45,-12,9,-74,65,-115,102, 64,-52, -10,-4,y,x,100);
  setMotors(-100,80,-68,68,-14,14,-45,45,-5,5,-68,54,-102,102, 49,-55,  -5,5,y,x,90);
  send_vel(270);
}

void  M_R(int w1, int w2){//шаг вправо боком
  send_vel(500);
  setMotors(-90,90,-68,68,-14,14,-45,45,-30,30,-83,83,-120,113, 60,-51, -5,5,w2,w1,150);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,10,-83,83,-120,113, 51,-51, -5,5,w2,w1,150);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-83,83,-113,113,51,-51,-5,5,w2,w1,200);
  send_vel(270);
}
void M_L(int w1, int w2){//шаг влево боком
send_vel(500);
  setMotors(-90,90,-68,68,-14,14,-45,45,-30,30,-83,83,-113,120, 51,-60, -5,5,w2,w1,200);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,10,-83,83,-113,120, 51,-51, -5,5,w2,w1,200);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-83,83,-113,113,51,-51,-5,5,w2,w1,200);
  send_vel(270);
}
void  TURN_R(int w1, int w2, bool ifsee){//повернуть направо на месте
  send_vel(500);
  for(int i = 0;i<10;i++)
    if(ifsee == true)setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,67,-103,102,50,-50,-1,1,y,x,15);
  setMotors(-90,90,-68,68,-14,14,-12,19,-1,1,-75,67,-117,103, 59,-50, -1,-1,y,x,65);
  setMotors(-90,90,-68,68,-14,14,-30,30,-1,1,-67,67,-103,103, 50,-50, -1,-1,y,x,80);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,50,-50,-1,1,y,x,100);
  for(int i = 0;i<5;i++)
    if(ifsee == true)setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,67,-103,102,50,-50,-1,1,y,x,15);
}
void TURN_L(int w1, int w2, bool ifsee){//повернуть налево на месте
  send_vel(500);
  for(int i = 0;i<10;i++)
    if(ifsee == true)setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,67,-103,102,49,-49,-1,1,y,x,15);
 setMotors(-90,90,-68,68,-14,14,-12,19,-1,1,-67,75,-103,117, 50,-59, -1,-1,y,x,65);
  setMotors(-90,90,-68,68,-14,14,-30,30,-1,1,-67,67,-103,103, 50,-50, -1,-1,y,x,80);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,50,-50,-1,1,y,x,100);
  for(int i = 0;i<5;i++)
    if(ifsee == true)setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-66,66,-103,102,50,-50,-1,1,y,x,15);
}
void F_Shoot_R(int w1, int w2){//удар правой
 setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,50,-50,-1,1,y,x,2000);
  send_vel(600);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,5,-67,67,-102,100, 30,-50,-8,-6,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,10,-67,67,-102,100, 20,-50,-8,-7,y,x,100);
  
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,10,-75,67,-120,100, 10,-50, -10,-7,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,10,-95,67,-70,102, -40,-50, -10,-7,y,x,200);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,10,-90,67,-80,102, 20,-50, -10,-7,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,10,-80,67,-120,100, 30,-50, -10,-7,y,x,100);
  
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-70,67,-110,100, 40,-50, -10,-7,y,x,100);
  send_vel(270);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,67,-100,100,50,-50,-1,1,y,x,1500);
}

void F_Shoot_L(int w1, int w2){//удар левой
   setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,51,-51,-1,1,y,x,2000);
  send_vel(600);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,1,-67,67,-100,102, 50,-30,8,8,y,x,80);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,1,-67,67,-100,102, 50,-20,8,8,y,x,80);
  
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,1,-67,75,-100,120, 50,-10, 9,10,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,1,-67,95,-102,70, 50,50, 9,10,y,x,200);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,1,-67,90,-102,80, 50,-10, 9,10,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-10,1,-67,80,-100,120, 50,-20, 9,10,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,70,-100,110, 50,-30, 9,10,y,x,100);
  send_vel(270);
  setMotors(-90,90,-68,68,-14,14,-45,45,-5,5,-67,67,-100,100,49,-49,-1,1,y,x,1500);
}
void GET_UP_BACK(int w1, int w2){//встать со спины
  setMotors(10,-10,85,-85,3,-3,-46,46,-1,1,26,-25,-117,117,83,-83,-1,1,y,x,500);
  setMotors(-26,26,34,-34,0,0,-45,45,-1,1,25,-25,-94,94,8,-8,-1,1,y,x,500);
  setMotors(10,-10,85,-85,3,-3,-45,45,-1,1,25,-25,-117,117,83,-83,-1,1,y,x,600);
    send_vel(450);
  setMotors(-42,42,36,-36,2,-2,-48,48,-1,1,25,-25,-106,106,83,-82,-1,1,y,x,500); //dop move1
  setMotors(-87,87,2,-2,2,-2,-46,46,-1,1,25,-25,-100,100,83,-83,-1,1,y,x,300);

  setMotors(-85,85,-18,18,-2,2,-46,46,-1,1,0,0,-97,97,73,-73,-1,1,y,x,200);//dop move 
  setMotors(-84,84,-32,32,-5,5,-45,45,-1,1,-25,25,-98,98,67,-67,-1,1,y,x,100);//dop move2
  setMotors(-82,82,-54,54,-11,11,-45,45,-1,1,-44,44,-100,100,57,-57,-1,1,y,x,100);
  setMotors(-81,81,-68,68,-14,14,-45,45,-1,1,-60,60,-100,100,49,-51,-1,1,y,x,1600);  
  send_vel(270);
}
void GET_UP_FRONT(int w1, int w2){//встать с живота
  setMotors(-81,81,0,0,14,-14,-46,46,-1,1,-48,48,-67,67,30,-30,-1,1,y,x,600);
  setMotors(-14,14,-4,4,-3,3,-46,46,-1,1,-48,48,-67,67,30,-30,-1,1,y,x,500);
  
  setMotors(29,-29,57,-57,-104,104,-46,46,-4,4,-133,133,-114,114,94,-94,-2,2,y,x,200); //dop move 1 aprilya
  setMotors(29,-29,0,0,-104,104,-46,46,-4,4,-133,133,-114,114,94,-94,-2,2,y,x,400); 
  
  setMotors(0,0,-22,22,-64,64,-46,46,-2,2,-130,130,-125,125,77,-77,-1,1,y,x,400);//DOP MOVE 1 
  
  setMotors(-25,25,-90,90,0,0,-46,46,0,0,-130,130,-138,138,56,-56,0,0,y,x,400);
  
  setMotors(-45,45,-71,71,-16,16,-46,46,0,0,-105,105,-142,142,55,-55,0,0,y,x,200);//dop move 
  send_vel(400);
  setMotors(-58,58,-70,70,-15,15,-45,45,0,0,-100,100,-125,125,54,-54,0,0,y,x,150);//dop move
  setMotors(-81,81,-71,71,-16,16,-46,46,0,0,-60,60,-130,130,60,-60,0,0,y,x,2000);// dop mov
  setMotors(-51,51,-71,71,-16,16,-45,45,0,0,-103,103,-124,124,54,-54,0,0,w2,w1,50);//dop move
  setMotors(-81,81,-68,68,-14,14,-45,45,-1,1,-55,55,-100,100,47,-47,-1,1,y,x,100);
  setMotors(-81,81,-68,68,-14,14,-45,45,-1,1,-60,60,-100,100,49,-49,-1,1,y,x,1600);
  send_vel(270);
  }

void CIRCLE_RIGHT(int w1, int w2){//обойти кругом с правой стороны
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
  setMotors(-90,90,-68,68,-14,14,-51,51,-23,23,-75,65,-115,103, 63,-50, -7,-1,y,x,200);
  setMotors(-90,90,-68,68,-14,14,-51,51,-10,10,-65,75,-103,115, 50,-63, -7,-1,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,75,-103,115,50,-55,-1,1,y,x,150);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,103,50,-50,-1,1,y,x,400);

 setMotors(-90,90,-68,68,-14,14,-12,19,-1,1,-67,75,-103,117, 50,-59, -1,-1,y,x,70);
  setMotors(-90,90,-68,68,-14,14,-30,30,-1,1,-67,67,-103,103, 50,-50, -1,-1,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,102,50,-50,-1,1,y,x,600);
 
  
 
}
void CIRCLE_LEFT(int w1, int w2){//обойти кругом с левой стороны
  ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
 ready_for_walk(x,y);
  setMotors(-90,90,-68,68,-14,14,-51,51,-23,23,-65,75,-103,115, 50,-63, -1,7,y,x,200);
  setMotors(-90,90,-68,68,-14,14,-51,51,-10,10,-75,65,-115,103, 63,-50, -1,7,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-75,65,-115,103,55,-50,-1,1,y,x,150);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-67,67,-103,103,50,-50,-1,1,w2,w1,400);

  setMotors(-90,90,-68,68,-14,14,-12,19,-1,1,-75,67,-117,103, 59,-50, -1,-1,y,x,70);
  setMotors(-90,90,-68,68,-14,14,-30,30,-1,1,-67,67,-103,103, 50,-50, -1,-1,y,x,100);
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-69,69,-103,102,50,-50,-1,1,y,x,600);
  
  
 
}
void Set_Head(int w1, int w2){//поднять голову
  
  setMotors(-90,90,-68,68,-14,14,-45,45,-1,1,-70,70,-103,102,50,-50,-1,1,w2,w1,20);
}
void Head_Up_Down(){//поднять или опустить голову к мячу
  if(y>=15){
    while(Ball_Detect==false && y <= 58){
      y = y + 2;
      Set_Head(x,y);
    }
  
    while(Ball_Detect==false && y > -20){
      y = y - 2;
      Set_Head(x,y);
    }
   
  }
  else{
    while(Ball_Detect==false && y > -20){
      y = y - 2;
      Set_Head(x,y);
    }
    
     while(Ball_Detect==false && y < 58){
      y = y + 2;
      Set_Head(x,y);
    }
    
  }
}
bool Search_Ball(){//поиск мяча
    Head_Up_Down();  
    if (Ball_Detect == false && x>=0 ){
      if(HeadLeft() == true){
        TURN_L(x,y,true);
        TURN_L(x,y,false);
        TURN_L(x,y,true);
        return true;}
      if(HeadRight() == true){
        TURN_R(x,y,true);
        TURN_R(x,y,false);
        TURN_R(x,y,true);
        return true;}
      x = 0;
      x_old = 10;
      TURN_L(x,y,false);
      TURN_L(x,y,false);
      TURN_L(x,y,false);
      TURN_L(x,y,false);
      TURN_L(x,y,false);
   
    }
    else if(Ball_Detect == false){   
      if(HeadRight() == true){
        TURN_R(x,y,true);
        TURN_R(x,y,false);
        TURN_R(x,y,true);
        return true;}
      if(HeadLeft() == true){
        TURN_L(x,y,true);
        TURN_L(x,y,false);
        TURN_L(x,y,true);
        return true;}
      x=0;
      x_old=-10;
      TURN_R(x,y,false);
      TURN_R(x,y,false);
      TURN_R(x,y,false);
      TURN_R(x,y,false);
      TURN_R(x,y,false);
    }
}
void set_head_speed(int vel){ //скорость движения моторчиков в шее
   goal_velocity[19] = 300; //increass neck speed
  dxl_wb.syncWrite(1,  goal_velocity);
}

bool HeadLeft(){//держать голову слева
    x=60;
    set_head_speed(300);
    ready_for_walk(x,y); 
    Head_Up_Down();
    set_head_speed(100);
    if(Ball_Detect == true)
      return true;
    else
      return false; 
}

bool HeadRight(){//держать голову справа
    x=-60;
    set_head_speed(300);
    ready_for_walk(x,y); 
    Head_Up_Down();
    set_head_speed(100);
    if(Ball_Detect == true)
      return true;
    else
      return false; 
}